Index: /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/zoo_service_loader.c
===================================================================
--- /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 512)
+++ /branches/PublicaMundi_David-devel/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 513)
@@ -39,40 +39,28 @@
 #include "service_zcfg.h"
 }
-
 #include "ulinet.h"
-
 #include <libintl.h>
 #include <locale.h>
 #include <string.h>
-
 #include "service.h"
-
-
 #include "service_internal.h"
-
 #ifdef USE_PYTHON
 #include "service_internal_python.h"
 #endif
-
 #ifdef USE_JAVA
 #include "service_internal_java.h"
 #endif
-
 #ifdef USE_PHP
 #include "service_internal_php.h"
 #endif
-
 #ifdef USE_JS
 #include "service_internal_js.h"
 #endif
-
 #ifdef USE_RUBY
 #include "service_internal_ruby.h"
 #endif
-
 #ifdef USE_PERL
 #include "service_internal_perl.h"
 #endif
-
 #include <dirent.h>
 #include <signal.h>
@@ -92,5 +80,4 @@
 #include <time.h>
 #include <stdarg.h>
-
 #ifdef WIN32
 extern "C"
@@ -115,8 +102,6 @@
 }
 #endif
-
 #define _(String) dgettext ("zoo-kernel",String)
 #define __(String) dgettext ("zoo-service",String)
-
 extern int getServiceFromFile (maps *, const char *, service **);
 
@@ -228,5 +213,6 @@
 int
 recursReaddirF (maps * m, xmlNodePtr n, char *conf_dir, char *prefix,
-                int saved_stdout, int level, void (func) (maps *, xmlNodePtr,
+                int saved_stdout, int level, void (func) (maps *,
+                                                          xmlNodePtr,
                                                           service *))
 {
@@ -250,11 +236,12 @@
   setMapInMaps (m, "lenv", "level", levels);
   while ((dp = readdir (dirp)) != NULL)
-    if ((dp->d_type == DT_DIR || dp->d_type == DT_LNK) && dp->d_name[0] != '.'
-        && strstr (dp->d_name, ".") == NULL)
+    if ((dp->d_type == DT_DIR || dp->d_type == DT_LNK)
+        && dp->d_name[0] != '.' && strstr (dp->d_name, ".") == NULL)
       {
 
         char *tmp =
-          (char *) malloc ((strlen (conf_dir) + strlen (dp->d_name) + 2) *
-                           sizeof (char));
+          (char *)
+          malloc ((strlen (conf_dir) + strlen (dp->d_name) +
+                   2) * sizeof (char));
         sprintf (tmp, "%s/%s", conf_dir, dp->d_name);
 
@@ -266,5 +253,5 @@
         sprintf (prefix, "%s.", dp->d_name);
 
-        //map* tmpMap=getMapFromMaps(m,"lenv",tmp1);
+        // map* tmpMap=getMapFromMaps(m,"lenv",tmp1);
 
         int res;
@@ -276,6 +263,6 @@
             setMapInMaps (m, "lenv", "level", levels1);
             res =
-              recursReaddirF (m, n, tmp, prefix, saved_stdout, level + 1,
-                              func);
+              recursReaddirF (m, n, tmp, prefix, saved_stdout,
+                              level + 1, func);
             sprintf (levels1, "%d", level);
             setMapInMaps (m, "lenv", "level", levels1);
@@ -308,6 +295,6 @@
               }
 #ifdef DEBUG
-            fprintf (stderr, "#################\n%s\n#################\n",
-                     tmps1);
+            fprintf (stderr,
+                     "#################\n%s\n#################\n", tmps1);
 #endif
             t = readServiceFile (m, tmps1, &s1, dp->d_name);
@@ -318,8 +305,12 @@
                 char tmp01[1024];
                 if (tmp00 != NULL)
-                  sprintf (tmp01, _("Unable to parse the ZCFG file: %s (%s)"),
+                  sprintf (tmp01,
+                           _
+                           ("Unable to parse the ZCFG file: %s (%s)"),
                            dp->d_name, tmp00->value);
                 else
-                  sprintf (tmp01, _("Unable to parse the ZCFG file: %s."),
+                  sprintf (tmp01,
+                           _
+                           ("Unable to parse the ZCFG file: %s."),
                            dp->d_name);
                 dup2 (saved_stdout, fileno (stdout));
@@ -511,6 +502,6 @@
               mapsToCharXXX (request_output_real_format, (char ***) outputs);
               *eres =
-                execute ((char ***) &main_conf[0], (char ***) &inputs[0],
-                         (char ***) &outputs[0]);
+                execute ((char ***) &main_conf[0],
+                         (char ***) &inputs[0], (char ***) &outputs[0]);
 #ifdef DEBUG
               fprintf (stderr, "Function run successfully \n");
@@ -524,5 +515,6 @@
 #ifdef WIN32
               errstr = GetLastError ();
-              fprintf (stderr, "Function %s failed to load because of %d\n",
+              fprintf (stderr,
+                       "Function %s failed to load because of %d\n",
                        r_inputs->value, errstr);
 #endif
@@ -556,11 +548,10 @@
                   free (tmpMsg);
 #ifdef DEBUG
-                  fprintf (stderr, "Function %s error %s\n", r_inputs->value,
-                           errstr);
+                  fprintf (stderr, "Function %s error %s\n",
+                           r_inputs->value, errstr);
 #endif
                   *eres = -1;
                   return;
                 }
-
 #ifdef DEBUG
 #ifdef WIN32
@@ -626,5 +617,6 @@
     {
       *eres =
-        zoo_java_support (&m, request_inputs, s1, &request_input_real_format,
+        zoo_java_support (&m, request_inputs, s1,
+                          &request_input_real_format,
                           &request_output_real_format);
     }
@@ -636,5 +628,6 @@
     {
       *eres =
-        zoo_php_support (&m, request_inputs, s1, &request_input_real_format,
+        zoo_php_support (&m, request_inputs, s1,
+                         &request_input_real_format,
                          &request_output_real_format);
     }
@@ -647,5 +640,6 @@
     {
       *eres =
-        zoo_perl_support (&m, request_inputs, s1, &request_input_real_format,
+        zoo_perl_support (&m, request_inputs, s1,
+                          &request_input_real_format,
                           &request_output_real_format);
     }
@@ -657,5 +651,6 @@
     {
       *eres =
-        zoo_js_support (&m, request_inputs, s1, &request_input_real_format,
+        zoo_js_support (&m, request_inputs, s1,
+                        &request_input_real_format,
                         &request_output_real_format);
     }
@@ -667,5 +662,6 @@
     {
       *eres =
-        zoo_ruby_support (&m, request_inputs, s1, &request_input_real_format,
+        zoo_ruby_support (&m, request_inputs, s1,
+                          &request_input_real_format,
                           &request_output_real_format);
     }
@@ -775,5 +771,6 @@
                       NULL,     // Thread handle not inheritable
                       FALSE,    // Set handle inheritance to FALSE
-                      CREATE_NO_WINDOW, // Apache won't wait until the end
+                      CREATE_NO_WINDOW, // Apache won't wait until 
+                      // the end
                       NULL,     // Use parent's environment block
                       NULL,     // Use parent's starting directory 
@@ -947,6 +944,6 @@
       else
         {
-          sprintf (tmpUrl, "http://%s:%s%s", cgiServerName, cgiServerPort,
-                   cgiScriptName);
+          sprintf (tmpUrl, "http://%s:%s%s", cgiServerName,
+                   cgiServerPort, cgiScriptName);
         }
 #ifdef DEBUG
@@ -1139,5 +1136,6 @@
           || strlen (r_inputs->name) == 0 || strlen (r_inputs->value) == 0)
         {
-          errorException (m, _("Mandatory <identifier> was not specified"),
+          errorException (m,
+                          _("Mandatory <identifier> was not specified"),
                           "MissingParameterValue", "identifier");
           freeMaps (&m);
@@ -1152,5 +1150,6 @@
       if (dirp == NULL)
         {
-          errorException (m, _("The specified path path doesn't exist."),
+          errorException (m,
+                          _("The specified path path doesn't exist."),
                           "InvalidParameterValue", conf_dir);
           freeMaps (&m);
@@ -1339,5 +1338,6 @@
           if (outputs_as_text == NULL)
             {
-              return errorException (m, _("Unable to allocate memory"),
+              return errorException (m,
+                                     _("Unable to allocate memory"),
                                      "InternalError", NULL);
             }
@@ -1354,5 +1354,7 @@
               if (outputs_as_text[i] == NULL)
                 {
-                  return errorException (m, _("Unable to allocate memory"),
+                  return errorException (m,
+                                         _
+                                         ("Unable to allocate memory"),
                                          "InternalError", NULL);
                 }
@@ -1398,6 +1400,6 @@
                       tmpn[strlen (tmpc) - strlen (tmpv)] = 0;
 #ifdef DEBUG
-                      fprintf (stderr, "OUTPUT DEF [%s]=[%s]\n", tmpn,
-                               tmpv + 1);
+                      fprintf (stderr, "OUTPUT DEF [%s]=[%s]\n",
+                               tmpn, tmpv + 1);
 #endif
                       if (tmp_output->content == NULL)
@@ -1444,5 +1446,6 @@
       else
         {
-          errorException (m, _("Parameter <DataInputs> was not specified"),
+          errorException (m,
+                          _("Parameter <DataInputs> was not specified"),
                           "MissingParameterValue", "DataInputs");
           freeMaps (&m);
@@ -1466,6 +1469,6 @@
         {
           char *tmp2 = url_decode (tmp1);
-          snprintf (cursor_input, (strlen (tmp2) + 1) * sizeof (char), "%s",
-                    tmp2);
+          snprintf (cursor_input, (strlen (tmp2) + 1) * sizeof (char),
+                    "%s", tmp2);
           free (tmp2);
           pToken = strtok (cursor_input, ";");
@@ -1494,5 +1497,6 @@
           if (inputs_as_text[i] == NULL)
             {
-              return errorException (m, _("Unable to allocate memory."),
+              return errorException (m,
+                                     _("Unable to allocate memory."),
                                      "InternalError", NULL);
             }
@@ -1535,5 +1539,6 @@
                     {
                       return errorException (m,
-                                             _("Unable to allocate memory."),
+                                             _
+                                             ("Unable to allocate memory."),
                                              "InternalError", NULL);
                     }
@@ -1553,10 +1558,11 @@
                 {
 #ifdef DEBUG
-                  fprintf (stderr, "*** KVP NON URL-ENCODED \n***%s***\n",
-                           tmpc);
+                  fprintf (stderr,
+                           "*** KVP NON URL-ENCODED \n***%s***\n", tmpc);
 #endif
                   char *tmpv1 = strstr (tmpc, "=");
 #ifdef DEBUG
-                  fprintf (stderr, "*** VALUE NON URL-ENCODED \n***%s***\n",
+                  fprintf (stderr,
+                           "*** VALUE NON URL-ENCODED \n***%s***\n",
                            tmpv1 + 1);
 #endif
@@ -1575,6 +1581,7 @@
                       map *lmap = getLastMap (tmpmaps->content);
                       char *tmpValue =
-                        (char *) malloc ((strlen (tmpv) + strlen (tmpc) + 1) *
-                                         sizeof (char));
+                        (char *)
+                        malloc ((strlen (tmpv) + strlen (tmpc) +
+                                 1) * sizeof (char));
                       sprintf (tmpValue, "%s@%s", tmpv + 1, tmpc);
                       free (lmap->value);
@@ -1585,7 +1592,8 @@
                     }
 #ifdef DEBUG
-                  fprintf (stderr, "*** NAME NON URL-ENCODED \n***%s***\n",
-                           tmpn1);
-                  fprintf (stderr, "*** VALUE NON URL-ENCODED \n***%s***\n",
+                  fprintf (stderr,
+                           "*** NAME NON URL-ENCODED \n***%s***\n", tmpn1);
+                  fprintf (stderr,
+                           "*** VALUE NON URL-ENCODED \n***%s***\n",
                            tmpv1 + 1);
 #endif
@@ -1595,7 +1603,7 @@
                     {
                       char *tmpx2 = url_decode (tmpv1 + 1);
-                      if (strncasecmp (tmpx2, "http://", 7) != 0 &&
-                          strncasecmp (tmpx2, "ftp://", 6) != 0 &&
-                          strncasecmp (tmpx2, "https://", 8) != 0)
+                      if (strncasecmp (tmpx2, "http://", 7) != 0
+                          && strncasecmp (tmpx2, "ftp://", 6) != 0
+                          && strncasecmp (tmpx2, "https://", 8) != 0)
                         {
                           char emsg[1024];
@@ -1650,6 +1658,6 @@
               else
                 {
-                  maps *testPresence =
-                    getMaps (request_input_real_format, tmpmaps->name);
+                  maps *testPresence = getMaps (request_input_real_format,
+                                                tmpmaps->name);
                   if (testPresence != NULL)
                     {
@@ -1659,6 +1667,6 @@
                         {
                           if (appendMapsToMaps
-                              (m, request_input_real_format, tmpmaps,
-                               elem) < 0)
+                              (m, request_input_real_format,
+                               tmpmaps, elem) < 0)
                             {
                               freeMaps (&m);
@@ -1735,6 +1743,7 @@
                        xmlStrlen (cur2->name)) == 0)
                     {
-                      xmlChar *val =
-                        xmlNodeListGetString (doc, cur2->xmlChildrenNode, 1);
+                      xmlChar *val = xmlNodeListGetString (doc,
+                                                           cur2->xmlChildrenNode,
+                                                           1);
                       if (tmpmaps == NULL)
                         {
@@ -1759,9 +1768,11 @@
                       (cur2->name, BAD_CAST "Title",
                        xmlStrlen (cur2->name)) == 0
-                      || xmlStrncasecmp (cur2->name, BAD_CAST "Abstract",
+                      || xmlStrncasecmp (cur2->name,
+                                         BAD_CAST "Abstract",
                                          xmlStrlen (cur2->name)) == 0)
                     {
-                      xmlChar *val =
-                        xmlNodeListGetString (doc, cur2->xmlChildrenNode, 1);
+                      xmlChar *val = xmlNodeListGetString (doc,
+                                                           cur2->xmlChildrenNode,
+                                                           1);
                       if (tmpmaps == NULL)
                         {
@@ -1807,5 +1818,6 @@
 #endif
                       const char *refs[5] =
-                        { "mimeType", "encoding", "schema", "method",
+                        { "mimeType", "encoding", "schema",
+                        "method",
                         "href"
                       };
@@ -1815,25 +1827,29 @@
                           fprintf (stderr, "*** %s ***", refs[l]);
 #endif
-                          xmlChar *val = xmlGetProp (cur2, BAD_CAST refs[l]);
+                          xmlChar *val = xmlGetProp (cur2,
+                                                     BAD_CAST refs[l]);
                           if (val != NULL && xmlStrlen (val) > 0)
                             {
                               if (tmpmaps->content != NULL)
-                                addToMap (tmpmaps->content, refs[l],
-                                          (char *) val);
+                                addToMap (tmpmaps->content,
+                                          refs[l], (char *) val);
                               else
                                 tmpmaps->content =
                                   createMap (refs[l], (char *) val);
-                              map *ltmp = getMap (tmpmaps->content, "method");
+                              map *ltmp = getMap (tmpmaps->content,
+                                                  "method");
                               if (l == 4)
                                 {
                                   if (!
                                       (ltmp != NULL
-                                       && strncmp (ltmp->value, "POST",
+                                       && strncmp (ltmp->value,
+                                                   "POST",
                                                    4) == 0)
                                       && CHECK_INET_HANDLE (hInternet))
                                     {
                                       if (loadRemoteFile
-                                          (&m, &tmpmaps->content, &hInternet,
-                                           (char *) val) != 0)
+                                          (&m,
+                                           &tmpmaps->content,
+                                           &hInternet, (char *) val) != 0)
                                         {
                                           freeMaps (&m);
@@ -1859,13 +1875,11 @@
 #endif
                       xmlNodePtr cur3 = cur2->children;
-                      /*      HINTERNET hInternetP;
-                         hInternetP=InternetOpen(
-                         #ifndef WIN32
-                         (LPCTSTR)
-                         #endif
-                         "ZooWPSClient\0",
-                         INTERNET_OPEN_TYPE_PRECONFIG,
-                         NULL,NULL, 0); */
-                      //hInternet.ihandle[hInternet.nb].header=NULL;
+                      /*
+                       * HINTERNET hInternetP; hInternetP=InternetOpen(
+                       * #ifndef WIN32 (LPCTSTR) #endif
+                       * "ZooWPSClient\0", INTERNET_OPEN_TYPE_PRECONFIG,
+                       * NULL,NULL, 0); 
+                       */
+                      // hInternet.ihandle[hInternet.nb].header=NULL;
                       while (cur3 != NULL)
                         {
@@ -1875,6 +1889,6 @@
                           if (cur3 == NULL)
                             break;
-                          if (xmlStrcasecmp (cur3->name, BAD_CAST "Header") ==
-                              0)
+                          if (xmlStrcasecmp
+                              (cur3->name, BAD_CAST "Header") == 0)
                             {
                               const char *ha[2];
@@ -1886,9 +1900,11 @@
                               for (hai = 0; hai < 2; hai++)
                                 {
-                                  xmlChar *val =
-                                    xmlGetProp (cur3, BAD_CAST ha[hai]);
+                                  xmlChar *val = xmlGetProp (cur3,
+                                                             BAD_CAST
+                                                             ha[hai]);
 #ifdef POST_DEBUG
-                                  fprintf (stderr, "%s = %s\n", ha[hai],
-                                           (char *) val);
+                                  fprintf (stderr,
+                                           "%s = %s\n",
+                                           ha[hai], (char *) val);
 #endif
                                   if (hai == 0)
@@ -1898,21 +1914,26 @@
                                   else
                                     {
-                                      has =
-                                        (char *)
-                                        malloc ((4 + xmlStrlen (val) +
-                                                 strlen (key)) *
-                                                sizeof (char));
+                                      has = (char *)
+                                        malloc ((4 +
+                                                 xmlStrlen
+                                                 (val) +
+                                                 strlen
+                                                 (key)) * sizeof (char));
                                       if (has == NULL)
                                         {
-                                          return errorException (m,
-                                                                 _
-                                                                 ("Unable to allocate memory."),
-                                                                 "InternalError",
-                                                                 NULL);
+                                          return
+                                            errorException
+                                            (m,
+                                             _
+                                             ("Unable to allocate memory."),
+                                             "InternalError", NULL);
                                         }
                                       snprintf (has,
-                                                (3 + xmlStrlen (val) +
-                                                 strlen (key)), "%s: %s", key,
-                                                (char *) val);
+                                                (3 +
+                                                 xmlStrlen
+                                                 (val) +
+                                                 strlen
+                                                 (key)),
+                                                "%s: %s", key, (char *) val);
                                       free (key);
 #ifdef POST_DEBUG
@@ -1923,7 +1944,6 @@
                                 }
                               hInternet.ihandle[hInternet.nb].header =
-                                curl_slist_append (hInternet.ihandle
-                                                   [hInternet.nb].header,
-                                                   has);
+                                curl_slist_append
+                                (hInternet.ihandle[hInternet.nb].header, has);
                               if (has != NULL)
                                 free (has);
@@ -1935,14 +1955,16 @@
                                        "Try to fetch the body part of the request ...\n");
 #endif
-                              if (xmlStrcasecmp (cur3->name, BAD_CAST "Body")
-                                  == 0)
+                              if (xmlStrcasecmp
+                                  (cur3->name, BAD_CAST "Body") == 0)
                                 {
 #ifdef POST_DEBUG
-                                  fprintf (stderr, "Body part found !!!\n",
+                                  fprintf (stderr,
+                                           "Body part found !!!\n",
                                            (char *) cur3->content);
 #endif
                                   char *tmp =
-                                    (char *) malloc (cgiContentLength +
-                                                     1 * sizeof (char));
+                                    (char *)
+                                    malloc
+                                    (cgiContentLength + 1 * sizeof (char));
                                   memset (tmp, 0, cgiContentLength);
                                   xmlNodePtr cur4 = cur3->children;
@@ -1970,38 +1992,35 @@
                                       xmlFreeDoc (bdoc);
                                     }
-                                  map *btmp =
-                                    getMap (tmpmaps->content, "href");
+                                  map *btmp = getMap (tmpmaps->content,
+                                                      "href");
                                   if (btmp != NULL)
                                     {
 #ifdef POST_DEBUG
-                                      fprintf (stderr, "%s %s\n", btmp->value,
-                                               tmp);
-                                      curl_easy_setopt (hInternet.handle,
-                                                        CURLOPT_VERBOSE, 1);
-#endif
-                                      hInternet.waitingRequests[hInternet.
-                                                                nb] =
-                                        strdup (tmp);
-                                      InternetOpenUrl (&hInternet,
-                                                       btmp->value,
-                                                       hInternet.
-                                                       waitingRequests
-                                                       [hInternet.nb],
-                                                       strlen (hInternet.
-                                                               waitingRequests
-                                                               [hInternet.
-                                                                nb]),
-                                                       INTERNET_FLAG_NO_CACHE_WRITE,
-                                                       0);
+                                      fprintf (stderr,
+                                               "%s %s\n", btmp->value, tmp);
+                                      curl_easy_setopt
+                                        (hInternet.handle,
+                                         CURLOPT_VERBOSE, 1);
+#endif
+                                      hInternet.waitingRequests
+                                        [hInternet.nb] = strdup (tmp);
+                                      InternetOpenUrl
+                                        (&hInternet,
+                                         btmp->value,
+                                         hInternet.waitingRequests
+                                         [hInternet.nb],
+                                         strlen
+                                         (hInternet.waitingRequests
+                                          [hInternet.nb]),
+                                         INTERNET_FLAG_NO_CACHE_WRITE, 0);
                                     }
                                   free (tmp);
                                 }
-                              else
-                                if (xmlStrcasecmp
-                                    (cur3->name,
-                                     BAD_CAST "BodyReference") == 0)
+                              else if (xmlStrcasecmp
+                                       (cur3->name,
+                                        BAD_CAST "BodyReference") == 0)
                                 {
-                                  xmlChar *val =
-                                    xmlGetProp (cur3, BAD_CAST "href");
+                                  xmlChar *val = xmlGetProp (cur3,
+                                                             BAD_CAST "href");
                                   HINTERNET bInternet, res1;
                                   bInternet = InternetOpen (
